import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class leftStick here.
 * 
 * @author (SilverCS) 
 * @version (v1.6)
 */
// LEFT STICK CODE
public class leftStick extends Actor
{
    // Using simpleTimer to setup a new timer method right away
    private SimpleTimer shotTimersp2 = new SimpleTimer();

    private SimpleTimer shotTimersp1 = new SimpleTimer();

    private SimpleTimer shotTimersp3 = new SimpleTimer();

    private SimpleTimer univShot = new SimpleTimer();

    // shield time heal
    private SimpleTimer shieldTimer = new SimpleTimer();

    // time in which counter-hit is possible
    private SimpleTimer counterTimer = new SimpleTimer();

    // set animation images
    GifImage idleanim = new GifImage("idlestickL.gif"); // Standing still left
    GreenfootImage blockanim = new GreenfootImage("backBlock.gif"); // Blocking left
    GifImage walkanim = new GifImage("walkingstickL.gif"); // Walking left
    GreenfootImage crouchanim = new GreenfootImage("idleCrouchLcpy.gif"); // Crouching left
    GreenfootImage sp2animL = new GreenfootImage("fireballL.gif"); // Sp2 left
    GifImage guardBrokenL = new GifImage("guardbrokenL.gif"); // guard broken left
    GreenfootImage sp3animL = new GreenfootImage("earthL.gif");
    GreenfootImage crouchBlockanim = new GreenfootImage("crouchBlockL.gif");

    //leftStick Audio
    GreenfootSound shieldFXL = new GreenfootSound("ShieldBlock.mp3");
    GreenfootSound guardBrokenFXL = new GreenfootSound("GuardBrokenSFX.mp3");
    GreenfootSound wakeUpFXL = new GreenfootSound("wakeUpSFX.mp3");
    GreenfootSound walkingFXL = new GreenfootSound("walkingSFX.mp3");
    GreenfootSound backwalkFXL = new GreenfootSound("backWalkSFX.mp3");
    GreenfootSound counterFXL = new GreenfootSound("counterSFX.mp3");

    // shield health starts at 3
    int shieldL = 3;

    boolean isGuardBroken = false;

    boolean attackBlocked = false;

    private boolean gbbHasPlayed = false;

    private boolean walkSounds = false;
    private boolean backWalkSounds = false;

    boolean shieldStart = false; // used to start the timer
    int shieldHeal = 9; // 3x3 (3 ticks, 3 seconds)

    // health bar starts at full
    int healthL = 100;

    // set health bar images L
    GreenfootImage hp0L = new GreenfootImage("hp0L.PNG");
    GreenfootImage hp10L = new GreenfootImage("hp10L.PNG");
    GreenfootImage hp20L = new GreenfootImage("hp20L.PNG");
    GreenfootImage hp30L = new GreenfootImage("hp30L.PNG");
    GreenfootImage hp40L = new GreenfootImage("hp40L.PNG");
    GreenfootImage hp50L = new GreenfootImage("hp50L.PNG");
    GreenfootImage hp60L = new GreenfootImage("hp60L.PNG");
    GreenfootImage hp70L = new GreenfootImage("hp70L.PNG");
    GreenfootImage hp80L = new GreenfootImage("hp80L.PNG");
    GreenfootImage hp90L = new GreenfootImage("hp90L.PNG");

    // set shieldBar images L
    GreenfootImage shield0L = new GreenfootImage("4shieldBroken.PNG");
    GreenfootImage shield1L = new GreenfootImage("3shieldLow.PNG");
    GreenfootImage shield2L = new GreenfootImage("2shieldCracked.PNG");
    GreenfootImage shield3L = new GreenfootImage("1shieldFull.PNG");

    // Super power One
    public void sp1waterL() 
    {
        GreenfootSound waterSFX = new GreenfootSound("waterSFX.mp3");
        waterSFX.play();
        waterCircle sp1indic = new waterCircle();
        getWorld().addObject(sp1indic, getX()+100, 370);
        waterballL sp1L = new waterballL();
        getWorld().addObject(sp1L, getX()+40, 370);
        sp1L.setRotation(getRotation());
        sp1L.move(40.0);
        shotTimersp1.mark();
        univShot.mark();

    } //end

    // Super power Two
    public void sp2fireL() 
    {
        GreenfootSound fireSFX = new GreenfootSound("fireSFX.mp3");
        fireSFX.play();
        fireCircle sp2indic = new fireCircle();
        getWorld().addObject(sp2indic, getX()+100, 370);
        fireballL sp2L = new fireballL();
        getWorld().addObject(sp2L, getX()+40, 370);
        sp2L.setRotation(getRotation());
        sp2L.move(40.0);
        shotTimersp2.mark();
        univShot.mark();

    } //end

    // Super power Three
    public void sp3earthL() 
    {
        GreenfootSound earthSFX = new GreenfootSound("earthSFX.mp3");
        earthSFX.play();
        earthCircle sp3indic = new earthCircle();
        getWorld().addObject(sp3indic, getX()+13, 485);
        earthL sp3L = new earthL();
        getWorld().addObject(sp3L, getX()+100, 485);
        sp3L.setRotation(getRotation());
        sp3L.move(40);
        shotTimersp3.mark();
        univShot.mark();

    } //end

    public void walkSounds()
    {
        if (walkSounds == true)
        {
            walkingFXL.play();

        }
        if (walkSounds == false)
        {
            walkingFXL.stop();

        }

    }

    public void backWalkSounds()
    {
        if (backWalkSounds == true)
        {
            backwalkFXL.play();

        }
        if (backWalkSounds == false)
        {
            backwalkFXL.stop();

        }

    }

    public void shieldRecovery()
    {

        if (shieldTimer.millisElapsed() > 3000){
            shieldStart = true;
            if (shieldStart == true)
            {
                shieldHeal--; // Or Timer = Timer - 1;
                if (shieldHeal <= 0)
                {
                    wakeUpFXL.play();
                    shieldL +=1;
                    isGuardBroken = false;
                    gbbHasPlayed = false;

                }
            }
        }

    }

    public void guardBreak()
    {

        if (shieldL < 3)
        { 
            shieldRecovery();

        }

        if (shieldL == 3)
        {
            shieldFullL.setImage("1shieldFull.PNG");

        }

        if (shieldL <= 0)
        {
            isGuardBroken = true;
            setImage(guardBrokenL.getCurrentImage());
            if (!gbbHasPlayed){
                guardBrokenFXL.play();
                gbbHasPlayed = true;

            }

        }

    }

    private Actor sp1OffL = new sp1OffL();
    private Actor sp1OnL = new sp1OnL();

    // USE SUPER POWER 2
    public void sp1check() {

        if (shotTimersp1.millisElapsed() < 1000 && univShot.millisElapsed() < 1000)
        {
            int sp1False = 0;

            switch (sp1False)
            {
                case 0:
                    getWorld().addObject(sp1OffL, 50, 26);
                    getWorld().removeObject(sp1OnL);
                    break;

            }

        }
        if (shotTimersp1.millisElapsed() > 1000 && univShot.millisElapsed() > 1000)
        {
            int sp1False = 1;
            switch (sp1False)
            {
                case 1:
                    getWorld().addObject(sp1OnL, 50, 26);
                    getWorld().removeObject(sp1OffL);
                    break;

            }
        }
        if (Greenfoot.isKeyDown("1"))
        {
            setImage(sp2animL);
            {
                sp1();
                int sp1False = 0;

            }
        }//end
    }//end

    private Actor sp2OffL = new sp2OffL();
    private Actor sp2OnL = new sp2OnL();

    // USE SUPER POWER 2
    public void sp2check() {

        if (shotTimersp2.millisElapsed() < 2000 && univShot.millisElapsed() < 1000)
        {
            int sp2False = 0;

            switch (sp2False)
            {
                case 0:
                    getWorld().addObject(sp2OffL, 118, 26);
                    getWorld().removeObject(sp2OnL);
                    break;

            }

        }
        if (shotTimersp2.millisElapsed() > 2000 && univShot.millisElapsed() > 1000)
        {
            int sp2False = 1;
            switch (sp2False)
            {
                case 1:
                    getWorld().addObject(sp2OnL, 118, 26);
                    getWorld().removeObject(sp2OffL);
                    break;

            }
        }
        if (Greenfoot.isKeyDown("2"))
        {
            setImage(sp2animL);
            {
                sp2();
                int sp2False = 0;

            }
        }//end
    }//end

    private Actor sp3OffL = new sp3OffL();
    private Actor sp3OnL = new sp3OnL();

    // USE SUPER POWER 3
    public void sp3check() {

        if (shotTimersp3.millisElapsed() < 3000 && univShot.millisElapsed() < 1000)
        {
            int sp3False = 0;

            switch (sp3False)
            {
                case 0:
                    getWorld().addObject(sp3OffL, 184, 26);
                    getWorld().removeObject(sp3OnL);
                    break;

            }

        }
        if (shotTimersp3.millisElapsed() > 3000 && univShot.millisElapsed() > 1000)
        {
            int sp3False = 1;
            switch (sp3False)
            {
                case 1:
                    getWorld().addObject(sp3OnL, 184, 26);
                    getWorld().removeObject(sp3OffL);
                    break;

            }
        }
        if (Greenfoot.isKeyDown("3"))
        {
            setImage(sp3animL);
            {
                sp3();
                int sp3False = 0;

            }
        }//end
    }//end

    private Actor hpFullL = new hpFullL();
    public void healthBarL()
    {
        switch (healthL){

            case 100:
                getWorld().addObject(hpFullL, 164, 565);
                break;
            case 90:
                hpFullL.setImage("hp90L.PNG");
                break;

            case 80:
                hpFullL.setImage("hp80L.PNG");
                break;

            case 70:
                hpFullL.setImage("hp70L.PNG");
                break;
            case 60:
                hpFullL.setImage("hp60L.PNG");
                break;
            case 50:
                hpFullL.setImage("hp50L.PNG");
                break;
            case 40:
                hpFullL.setImage("hp40L.PNG");
                break;
            case 30:
                hpFullL.setImage("hp30L.PNG");
                break;
            case 20:
                hpFullL.setImage("hp20L.PNG");
                break;
            case 10:
                hpFullL.setImage("hp10L.PNG");
                break;
            case 0:
                hpFullL.setImage("hp0L.PNG");
                getWorld().showText("Left Player was Killed!", 120, 100);
                Greenfoot.delay(110);
                Greenfoot.setWorld(new StartScreen());
                break;
        }
    }

    private Actor shieldFullL = new shieldFullL();

    public void shieldBar()
    {
        switch (shieldL)
        {
            case 3:

                getWorld().addObject(shieldFullL, 195, 538);
                break;

            case 2:

                shieldFullL.setImage("2shieldCracked.PNG");
                break;

            case 1:

                shieldFullL.setImage("3shieldLow.PNG");
                break;

            case 0:
                shieldFullL.setImage("4shieldBroken.PNG");
                break;

        }
    }

    public void deathL()
    {
        if (healthL <= 0)
        {
            hpFullL.setImage("hp0L.PNG");
            getWorld().showText("Left Player was Killed!", 120, 100);
            Greenfoot.delay(110);
            Greenfoot.setWorld(new StartScreen());

        }

    }

    // Idle Method
    void idle () {
        boolean isIdle = true;
        if (isIdle == true && isGuardBroken == false) {
            setImage(idleanim.getCurrentImage());
            checkObstacle();
            walkSounds = false;
            backWalkSounds = false;
        } //end

    } //end

    // blocking Method
    public void blocking () {
        if (Greenfoot.isKeyDown("q") && isGuardBroken == false) {
            if (Greenfoot.isKeyDown("3") == false)
            // 01 cannot block if sp2
                if (Greenfoot.isKeyDown("2") == false)
                    if(Greenfoot.isKeyDown("1") == false)
                    {
                        boolean isBlocking = true;
                        setLocation(getX()-0, getY());
                        setImage(new GreenfootImage(blockanim));
                        checkObstacle();
                        walkSounds = false;
                        backWalkSounds = false;
                    } //end
        } //end

    } //end

    void backWalking () {
        if (Greenfoot.isKeyDown("a") && isGuardBroken == false) {
            // 01 cannot backWalk if already blocking
            if (Greenfoot.isKeyDown("q") == false)
                if (Greenfoot.isKeyDown("3") == false)

                // 01 cannot backWalk if already jumping
                    if (Greenfoot.isKeyDown("w") == false)
                    // 01 cannot backWalk if sp2
                        if (Greenfoot.isKeyDown("2") == false)
                            if(Greenfoot.isKeyDown("1") == false)
                            // 01 cannot crouch if already backwalking
                                if (Greenfoot.isKeyDown("s") == false)
                                {
                                    setLocation(getX()-3, getY());
                                    boolean isBackWalking = true;
                                    checkObstacle();
                                    walkSounds = false;
                                    backWalkSounds = true;

                                } //end

        } //end

    } //end

    // crouching method
    void crouching () {
        if (Greenfoot.isKeyDown("s") && isGuardBroken == false) {

            setLocation(getX(),440);
            setImage(crouchanim);
            boolean isCrouching = true;
            walkSounds = false;
            backWalkSounds = false;
            checkObstacle();

        } //end
    } //end

    // crouch blocking method
    void crouchBlock () 
    {
        if (Greenfoot.isKeyDown("s") && Greenfoot.isKeyDown("q") && isGuardBroken == false) {

            setLocation(getX(),440);
            setImage(crouchBlockanim);
            boolean isBlockCrouching = true;
            walkSounds = false;
            backWalkSounds = false;
            checkObstacle();

        }
    }
    // walking method
    void walking () {
        if (Greenfoot.isKeyDown("d") && isGuardBroken == false) {
            // 01 cannot walk if already blocking
            if (Greenfoot.isKeyDown("q") == false)
            // 01 cannot walk if already jumping
                if (Greenfoot.isKeyDown("w") == false)
                // 01 cannot walk if already backWalking
                    if (Greenfoot.isKeyDown("a") == false)

                    // 01 cannot walk if crouching
                        if (Greenfoot.isKeyDown("s") == false)
                        // 01 cannot walk if sp2
                            if (Greenfoot.isKeyDown("2") == false)
                                if (Greenfoot.isKeyDown("3") == false)
                                    if(Greenfoot.isKeyDown("1") == false)
                                    {
                                        walkSounds = true;
                                        setLocation(getX()+4, getY());
                                        setImage(walkanim.getCurrentImage());
                                        boolean isWalking = true;
                                        checkObstacle();
                                        backWalkSounds = false;

                                    } //end

        } //end

    } //end

    public void sp1 () {

        if (Greenfoot.isKeyDown("1") && isGuardBroken == false && univShot.millisElapsed() > 1000){

            setImage(sp2animL);
            if (shotTimersp1.millisElapsed() > 1000)
            {
                sp1waterL();
                walkSounds = false;
                backWalkSounds = false;

            } //end

        } //end
    } //end

    public void sp2 () {
        if (Greenfoot.isKeyDown("2") && isGuardBroken == false && univShot.millisElapsed() > 1000){
            setImage(sp2animL);
            if (shotTimersp2.millisElapsed() > 2000)
            {
                sp2fireL();
                walkSounds = false;
                backWalkSounds = false;

            } //end

        } //end
    } //end

    public void sp3 () {

        if (Greenfoot.isKeyDown("3") && isGuardBroken == false && univShot.millisElapsed() > 1000){

            setLocation(getX(),440);
            setImage(sp3animL);
            if (shotTimersp3.millisElapsed() > 3000)
            {
                sp3earthL();
                walkSounds = false;
                backWalkSounds = false;

            } //end

        } //end
    } //end

    public void hitDetectionSp1L () {
        Actor waterballR = getOneIntersectingObject(waterballR.class);
        Actor waterballL = getOneIntersectingObject(waterballL.class);
        if (waterballR!=null && Greenfoot.isKeyDown("s") == false && Greenfoot.isKeyDown("q") == false){

            healthL -= 10; 
            getWorld().removeObject(waterballR);
            attackBlocked = false;

        }//end

        if (waterballR!=null && Greenfoot.isKeyDown("s") == true && isGuardBroken == true)
        {
            healthL -= 10; 
            getWorld().removeObject(waterballR);
            attackBlocked = false;

        }

        if (waterballR!=null && Greenfoot.isKeyDown("q") == true && isGuardBroken == true)
        {
            healthL -= 10; 
            getWorld().removeObject(waterballR);
            attackBlocked = false;

        }

        if (waterballR!=null && Greenfoot.isKeyDown("1") == true){
            healthL -= 10; 
            getWorld().removeObject(waterballR);
            attackBlocked = false;
        }

        if (waterballR!=null && Greenfoot.isKeyDown("q") == true && Greenfoot.isKeyDown("s") == false && Greenfoot.isKeyDown("1") == false && isGuardBroken == false)
        {
            getWorld().removeObject(waterballR);
            shieldFXL.play();
            shieldTimer.mark();
            shieldL -=1;
            attackBlocked = true;
            counterTimer.mark();
        }//end

        if (waterballL!=null && attackBlocked == true && counterTimer.millisElapsed() < 1000)
        {
            counterFXL.play();
            attackBlocked = false;

        }

    }//end

    public void hitDetectionSp2L () {
        Actor fireballR = getOneIntersectingObject(fireballR.class);
        Actor fireballL = getOneIntersectingObject(fireballL.class);
        if (fireballR!=null && Greenfoot.isKeyDown("s") == false && Greenfoot.isKeyDown("q") == false){

            healthL -= 20; 
            getWorld().removeObject(fireballR);
            attackBlocked = false;

        }//end

        if (fireballR!=null && Greenfoot.isKeyDown("s") == true && isGuardBroken == true)
        {
            healthL -= 20; 
            getWorld().removeObject(fireballR);
            attackBlocked = false;

        }

        if (fireballR!=null && Greenfoot.isKeyDown("q") == true && isGuardBroken == true)
        {
            healthL -= 20; 
            getWorld().removeObject(fireballR);
            attackBlocked = false;

        }

        if (fireballR!=null && Greenfoot.isKeyDown("2") == true){
            healthL -= 20; 
            getWorld().removeObject(fireballR);
            attackBlocked = false;
        }

        if (fireballR!=null && Greenfoot.isKeyDown("q") == true && Greenfoot.isKeyDown("s") == false && Greenfoot.isKeyDown("2") == false && isGuardBroken == false)
        {
            getWorld().removeObject(fireballR);
            shieldFXL.play();
            shieldTimer.mark();
            shieldL -=1;
            attackBlocked = true;
            counterTimer.mark();
        }//end

        if (fireballL!=null && attackBlocked == true && counterTimer.millisElapsed() < 1000)
        {
            counterFXL.play();
            attackBlocked = false;

        }

    }//end

    public void hitDetectionSp3L () {
        Actor earthR = getOneIntersectingObject(earthR.class);
        Actor earthL = getOneIntersectingObject(earthL.class);
        if (earthR!=null && Greenfoot.isKeyDown("q") == false){

            healthL -= 20; 
            getWorld().removeObject(earthR);
            attackBlocked = false;

        }//end

        if (earthR!=null && isGuardBroken == true)
        {
            healthL -= 20; 
            getWorld().removeObject(earthR);
            attackBlocked = false;

        }

        if (earthR!=null && Greenfoot.isKeyDown("q") == true && isGuardBroken == true)
        {
            healthL -= 20; 
            getWorld().removeObject(earthR);
            attackBlocked = false;

        }

        if (earthR!=null && Greenfoot.isKeyDown("q") == true && Greenfoot.isKeyDown("s") == false && isGuardBroken == false)
        {
            healthL -= 20; 
            getWorld().removeObject(earthR);
            attackBlocked = false;

        }

        if (earthR!=null && Greenfoot.isKeyDown("3") == true){
            healthL -= 20; 
            getWorld().removeObject(earthR);
            attackBlocked = false;
        }

        if (earthR!=null && Greenfoot.isKeyDown("q") == true && Greenfoot.isKeyDown("s") == true && Greenfoot.isKeyDown("3") == false && isGuardBroken == false)
        {
            getWorld().removeObject(earthR);
            shieldFXL.play();
            shieldTimer.mark();
            shieldL -=1;
            attackBlocked = true;
            counterTimer.mark();
        }//end

        if (earthL!=null && attackBlocked == true && counterTimer.millisElapsed() < 1000)
        {
            counterFXL.play();
            attackBlocked = false;

        }

    }//end

    public void checkObstacle()
    {
        Actor midWall = getOneIntersectingObject(blackLine.class);
        Actor leftWall = getOneIntersectingObject(leftWall.class);
        if (midWall!=null)
        {
            move(-4);

        }//end
        if (leftWall!=null)
        {
            move(+4);

        }//end

    }//end

    // ACT METHOD IS HERE
    public void act()
    {
        // by default, stick01 is idle
        idle();

        // stickman01 blocks upon pressing "q" key
        blocking();

        // stickman01 backWalks upon pressing the "a" key
        backWalking();

        // stickman01 crouches upon pressing the "s" key
        crouching();

        crouchBlock();

        // stickman01 walks upon pressing the "d" key
        walking();

        // makes footstep noises
        walkSounds();

        // makes backstep noises
        backWalkSounds();

        // stickman01 casts a fireball (super-power-#2) upon pressing the "2" key
        sp2check();

        sp1check();

        sp3check();

        // if stickman01 is hit by stickman02's sp2 then stickman01 will die lol 
        hitDetectionSp3L();

        hitDetectionSp2L();

        hitDetectionSp1L();

        //stickman01 healthbar
        healthBarL();
        deathL();

        //stickman01 shieldbar
        shieldBar();

        //stickman01 guardbroken
        guardBreak();

    } //end
} //end
