import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class rightStick here.
 * 
 * @author (SilverCS) 
 * @version (v1.6)
 */
// RIGHT STICK CODE
public class rightStick extends Actor
{
    // Using simpleTimer to setup a new timer method right away
    private SimpleTimer shotTimersp2 = new SimpleTimer();

    private SimpleTimer shotTimersp1 = new SimpleTimer();

    private SimpleTimer shotTimersp3 = new SimpleTimer();

    // shield time heal
    private SimpleTimer shieldTimer = new SimpleTimer();

    // time in which counter-hit is possible
    private SimpleTimer counterTimer = new SimpleTimer();

    private SimpleTimer univShot = new SimpleTimer();

    // set animation images
    GifImage idleanim = new GifImage("idlewhitestickR.gif"); // Standing still left
    GreenfootImage blockanim = new GreenfootImage("backBlockR.gif"); // Blocking left
    GifImage walkanim = new GifImage("whitestickR.gif"); // Walking left
    GreenfootImage crouchanim = new GreenfootImage("idleCrouchRcpy.gif"); // Crouching left
    GreenfootImage sp2animR = new GreenfootImage("fireballR.gif"); // Sp2 left
    GifImage guardBrokenR = new GifImage("guardbrokenR.gif"); // guard broken left
    GreenfootImage sp3animR = new GreenfootImage("earthR.gif");
    GreenfootImage crouchBlockanim = new GreenfootImage("crouchBlockR.gif");

    //rightStick Audio
    GreenfootSound shieldFXR = new GreenfootSound("ShieldBlock.mp3");
    GreenfootSound guardBrokenFXR = new GreenfootSound("GuardBrokenSFX.mp3");
    GreenfootSound wakeUpFXR = new GreenfootSound("wakeUpSFX.mp3");
    GreenfootSound walkingFXR = new GreenfootSound("walkingSFX.mp3");
    GreenfootSound backwalkFXR = new GreenfootSound("backWalkSFX.mp3");
    GreenfootSound counterFXR = new GreenfootSound("counterSFX.mp3");

    // shield health starts at 3
    int shieldR = 3;

    boolean isGuardBroken = false;
    boolean attackBlocked = false;

    private boolean walkSounds = false;
    private boolean backWalkSounds = false;

    private boolean gbbHasPlayed = false;

    boolean shieldStart = false; // used to start the timer
    int shieldHeal = 9; // 3x3 (3 ticks, 3 seconds)

    // health bar starts at full
    int healthR = 100;

    // set health bar images L
    GreenfootImage hp0R = new GreenfootImage("hp0R.PNG");
    GreenfootImage hp10R = new GreenfootImage("hp10R.PNG");
    GreenfootImage hp20R = new GreenfootImage("hp20R.PNG");
    GreenfootImage hp30R = new GreenfootImage("hp30R.PNG");
    GreenfootImage hp40R = new GreenfootImage("hp40R.PNG");
    GreenfootImage hp50R = new GreenfootImage("hp50R.PNG");
    GreenfootImage hp60R = new GreenfootImage("hp60R.PNG");
    GreenfootImage hp70R = new GreenfootImage("hp70R.PNG");
    GreenfootImage hp80R = new GreenfootImage("hp80R.PNG");
    GreenfootImage hp90R = new GreenfootImage("hp90R.PNG");

    // set shieldBar images L
    GreenfootImage shield0R = new GreenfootImage("4shieldBroken.PNG");
    GreenfootImage shield1R = new GreenfootImage("3shieldLow.PNG");
    GreenfootImage shield2R = new GreenfootImage("2shieldCracked.PNG");
    GreenfootImage shield3R = new GreenfootImage("1shieldFull.PNG");

    // Super power One
    public void sp1waterR() 
    {
        GreenfootSound waterSFX = new GreenfootSound("waterSFX.mp3");
        waterSFX.play();
        waterCircle sp1indic = new waterCircle();
        getWorld().addObject(sp1indic, getX()-100, 370);
        waterballR sp1R = new waterballR();
        getWorld().addObject(sp1R, getX()-40, 370);
        sp1R.setRotation(getRotation());
        sp1R.move(40.0);
        shotTimersp1.mark();
        univShot.mark();

    } //end

    // Super power Two
    public void sp2fireR() 
    {
        GreenfootSound fireSFX = new GreenfootSound("fireSFX.mp3");
        fireSFX.play();
        fireCircle sp2indic = new fireCircle();
        getWorld().addObject(sp2indic, getX()-100, 370);
        fireballR sp2R = new fireballR();
        getWorld().addObject(sp2R, getX()-40, 370);
        sp2R.setRotation(getRotation());
        sp2R.move(40.0);
        shotTimersp2.mark();
        univShot.mark();

    } //end

    // Super power Three
    public void sp3earthR() 
    {
        GreenfootSound earthSFX = new GreenfootSound("earthSFX.mp3");
        earthSFX.play();
        earthCircle sp3indic = new earthCircle();
        getWorld().addObject(sp3indic, getX()-13, 485);
        earthR sp3R = new earthR();
        getWorld().addObject(sp3R, getX()-100, 485);
        sp3R.setRotation(getRotation());
        sp3R.move(40);
        shotTimersp3.mark();
        univShot.mark();

    } //end

    public void walkSounds()
    {
        if (walkSounds == true)
        {
            walkingFXR.play();

        }
        if (walkSounds == false)
        {
            walkingFXR.stop();

        }

    }

    public void backWalkSounds()
    {
        if (backWalkSounds == true)
        {
            backwalkFXR.play();

        }
        if (backWalkSounds == false)
        {
            backwalkFXR.stop();

        }

    }

    public void shieldRecovery()
    {

        if (shieldTimer.millisElapsed() > 3000){
            shieldStart = true;
            if (shieldStart == true)
            {
                shieldHeal--; // Or Timer = Timer - 1;
                if (shieldHeal <= 0)
                {
                    wakeUpFXR.play();
                    shieldR +=1;
                    isGuardBroken = false;
                    gbbHasPlayed = false;

                }
            }
        }

    }

    public void guardBreak()
    {

        if (shieldR < 3)
        { 
            shieldRecovery();

        }

        if (shieldR == 3)
        {
            shieldFullR.setImage("1shieldFull.PNG");

        }

        if (shieldR <= 0)
        {
            isGuardBroken = true;
            setImage(guardBrokenR.getCurrentImage());
            if (!gbbHasPlayed){
                guardBrokenFXR.play();
                gbbHasPlayed = true;

            }

        }

    }
    private Actor sp1OffR = new sp1OffR();
    private Actor sp1OnR = new sp1OnR();

    // USE SUPER POWER 2
    public void sp1check() {

        if (shotTimersp1.millisElapsed() < 1000 && univShot.millisElapsed() < 1000)
        {
            int sp1False = 0;

            switch (sp1False)
            {
                case 0:
                    getWorld().addObject(sp1OffR, 750, 26);
                    getWorld().removeObject(sp1OnR);
                    break;

            }

        }
        if (shotTimersp1.millisElapsed() > 1000 && univShot.millisElapsed() > 1000)
        {
            int sp1False = 1;
            switch (sp1False)
            {
                case 1:
                    getWorld().addObject(sp1OnR, 750, 26);
                    getWorld().removeObject(sp1OffR);
                    break;

            }
        }
        if (Greenfoot.isKeyDown("0"))
        {
            setImage(sp2animR);
            {
                sp1();
                int sp1False = 0;

            }
        }//end
    }//end

    private Actor sp2OffR = new sp2OffR();
    private Actor sp2OnR = new sp2OnR();

    // USE SUPER POWER 2
    public void sp2check() {

        if (shotTimersp2.millisElapsed() < 2000 && univShot.millisElapsed() < 1000)
        {
            int sp2False = 0;

            switch (sp2False)
            {
                case 0:
                    getWorld().addObject(sp2OffR, 682, 26);
                    getWorld().removeObject(sp2OnR);

                    break;

            }

        }
        if (shotTimersp2.millisElapsed() > 2000 && univShot.millisElapsed() > 1000)
        {
            int sp2False = 1;
            switch (sp2False)
            {
                case 1:
                    getWorld().addObject(sp2OnR, 682, 26);
                    getWorld().removeObject(sp2OffR);
                    break;

            }
        }
        if (Greenfoot.isKeyDown("9"))
        {
            setImage(sp2animR);
            {
                sp2();
                int sp2False = 0;

            }
        }//end
    }//end

    private Actor sp3OffR = new sp3OffR();
    private Actor sp3OnR = new sp3OnR();

    // USE SUPER POWER 3
    public void sp3check() {

        if (shotTimersp3.millisElapsed() < 3000 && univShot.millisElapsed() < 1000)
        {
            int sp3False = 0;

            switch (sp3False)
            {
                case 0:
                    getWorld().addObject(sp3OffR, 616, 26);
                    getWorld().removeObject(sp3OnR);
                    break;

            }

        }
        if (shotTimersp3.millisElapsed() > 3000 && univShot.millisElapsed() > 1000)
        {
            int sp3False = 1;
            switch (sp3False)
            {
                case 1:
                    getWorld().addObject(sp3OnR, 616, 26);
                    getWorld().removeObject(sp3OffR);
                    break;

            }
        }
        if (Greenfoot.isKeyDown("8"))
        {
            setImage(sp3animR);
            {
                sp3();
                int sp3False = 0;

            }
        }//end
    }//end

    private Actor hpFullR = new hpFullR();
    public void healthBarR()
    {
        switch (healthR){

            case 100:
                getWorld().addObject(hpFullR, 637, 565);
                break;
            case 90:
                hpFullR.setImage("hp90R.PNG");
                break;

            case 80:
                hpFullR.setImage("hp80R.PNG");
                break;

            case 70:
                hpFullR.setImage("hp70R.PNG");
                break;
            case 60:
                hpFullR.setImage("hp60R.PNG");
                break;
            case 50:
                hpFullR.setImage("hp50R.PNG");
                break;
            case 40:
                hpFullR.setImage("hp40R.PNG");
                break;
            case 30:
                hpFullR.setImage("hp30R.PNG");
                break;
            case 20:
                hpFullR.setImage("hp20R.PNG");
                break;
            case 10:
                hpFullR.setImage("hp10R.PNG");
                break;
            case 0:
                hpFullR.setImage("hp0R.PNG");
                getWorld().showText("Right Player was Killed!", 675, 100);
                Greenfoot.delay(110);
                Greenfoot.setWorld(new StartScreen());
                break;
        }
    }

    private Actor shieldFullR = new shieldFullR();

    public void shieldBar()
    {
        switch (shieldR)
        {
            case 3:

                getWorld().addObject(shieldFullR, 667, 538);
                break;

            case 2:

                shieldFullR.setImage("2shieldCracked.PNG");
                break;

            case 1:

                shieldFullR.setImage("3shieldLow.PNG");
                break;

            case 0:
                shieldFullR.setImage("4shieldBroken.PNG");
                break;

        }
    }

    public void deathR()
    {
        if (healthR <= 0)
        {
            hpFullR.setImage("hp0R.PNG");
            getWorld().showText("Right Player was Killed!", 675, 100);
            Greenfoot.delay(110);
            Greenfoot.setWorld(new StartScreen());

        }

    }
    // Idle Method
    void idle () {
        boolean isIdle = true;
        if (isIdle == true && isGuardBroken == false) {
            setImage(idleanim.getCurrentImage());
            checkObstacle();
            walkSounds = false;
            backWalkSounds = false;
        } //end

    } //end

    // blocking Method
    public void blocking () {
        if (Greenfoot.isKeyDown("o") && isGuardBroken == false) {
            // 02 cannot block if sp2
            if (Greenfoot.isKeyDown("9") == false)
                if (Greenfoot.isKeyDown("8") == false)
                    if (Greenfoot.isKeyDown("0") == false){
                        boolean isBlocking = true;
                        setLocation(getX()-0, getY());
                        setImage(new GreenfootImage(blockanim));
                        checkObstacle();
                        walkSounds = false;
                        backWalkSounds = false;
                    } //end
        } //end

    } //end

    void backWalking () {
        if (Greenfoot.isKeyDown("l") && isGuardBroken == false) {
            // 02 cannot backWalk if already blocking
            if (Greenfoot.isKeyDown("o") == false)

            // 01 cannot backWalk if already jumping
                if (Greenfoot.isKeyDown("i") == false)
                // 01 cannot backWalk if sp2
                    if (Greenfoot.isKeyDown("9") == false)
                        if (Greenfoot.isKeyDown("8") == false)
                            if (Greenfoot.isKeyDown("0") == false)
                            // 01 cannot crouch if already backwalking
                                if (Greenfoot.isKeyDown("k") == false)
                                {
                                    setLocation(getX()+3, getY());
                                    boolean isBackWalking = true;
                                    checkObstacle();
                                    walkSounds = false;
                                    backWalkSounds = true;

                                } //end

        } //end

    } //end

    // crouching method
    void crouching () {
        if (Greenfoot.isKeyDown("k") && isGuardBroken == false) {

            setLocation(getX(),440);
            setImage(crouchanim);
            boolean isCrouching = true;
            checkObstacle();
            walkSounds = false;
            backWalkSounds = false;
        } //end
    } //end

    // crouch blocking method
    void crouchBlock () 
    {
        if (Greenfoot.isKeyDown("k") && Greenfoot.isKeyDown("o") && isGuardBroken == false) {

            setLocation(getX(),440);
            setImage(crouchBlockanim);
            boolean isBlockCrouching = true;
            walkSounds = false;
            backWalkSounds = false;
            checkObstacle();

        }
    }

    // walking method
    void walking () {
        if (Greenfoot.isKeyDown("j") && isGuardBroken == false) {
            // 01 cannot walk if already blocking
            if (Greenfoot.isKeyDown("o") == false)
            // 01 cannot walk if already jumping
                if (Greenfoot.isKeyDown("i") == false)
                // 01 cannot walk if already backWalking
                    if (Greenfoot.isKeyDown("l") == false)

                    // 01 cannot walk if crouching
                        if (Greenfoot.isKeyDown("k") == false)
                        // 01 cannot walk if sp2
                            if (Greenfoot.isKeyDown("9") == false)
                                if (Greenfoot.isKeyDown("8") == false)
                                    if (Greenfoot.isKeyDown("0") == false)
                                    {

                                        setLocation(getX()-4, getY());
                                        setImage(walkanim.getCurrentImage());
                                        boolean isWalking = true;
                                        checkObstacle();
                                        walkSounds = true;
                                        backWalkSounds = false;

                                    } //end

        } //end

    } //end

    public void sp1 () {
        if (Greenfoot.isKeyDown("0") && isGuardBroken == false && univShot.millisElapsed() > 1000){
            setImage(sp2animR);
            if (shotTimersp1.millisElapsed() > 1000)
            {
                sp1waterR();
                walkSounds = false;
                backWalkSounds = false;

            } //end

        } //end
    } //end

    public void sp2 () {
        if (Greenfoot.isKeyDown("9") && isGuardBroken == false && univShot.millisElapsed() > 1000){
            setImage(sp2animR);
            if (shotTimersp2.millisElapsed() > 2000)
            {
                sp2fireR();
                walkSounds = false;
                backWalkSounds = false;

            } //end

        } //end
    } //end

    public void sp3 () {

        if (Greenfoot.isKeyDown("8") && isGuardBroken == false && univShot.millisElapsed() > 1000){

            setLocation(getX(),440);
            setImage(sp3animR);
            if (shotTimersp3.millisElapsed() > 3000)
            {
                sp3earthR();
                walkSounds = false;
                backWalkSounds = false;

            } //end

        } //end
    } //end

    public void hitDetectionSp1R () {
        Actor waterballR = getOneIntersectingObject(waterballR.class);
        Actor waterballL = getOneIntersectingObject(waterballL.class);
        if (waterballL!=null && Greenfoot.isKeyDown("k") == false && Greenfoot.isKeyDown("o") == false){

            healthR -= 10; 
            getWorld().removeObject(waterballL);
            attackBlocked = false;

        }//end

        if (waterballL!=null && Greenfoot.isKeyDown("k") == true && isGuardBroken == true)
        {
            healthR -= 10; 
            getWorld().removeObject(waterballR);
            attackBlocked = false;

        }

        if (waterballL!=null && Greenfoot.isKeyDown("o") == true && isGuardBroken == true)
        {
            healthR -= 10; 
            getWorld().removeObject(waterballL);
            attackBlocked = false;

        }

        if (waterballL!=null && Greenfoot.isKeyDown("0") == true){
            healthR -= 10; 
            getWorld().removeObject(waterballL);
            attackBlocked = false;
        }

        if (waterballL!=null && Greenfoot.isKeyDown("o") == true && Greenfoot.isKeyDown("k") == false && Greenfoot.isKeyDown("0") == false && isGuardBroken == false)
        {
            getWorld().removeObject(waterballL);
            shieldFXR.play();
            shieldTimer.mark();
            shieldR -=1;
            attackBlocked = true;
            counterTimer.mark();
        }//end

        if (waterballR!=null && attackBlocked == true && counterTimer.millisElapsed() < 1000)
        {
            counterFXR.play();
            attackBlocked = false;

        }

    }//end

    public void hitDetectionSp2R () {
        Actor fireballL = getOneIntersectingObject(fireballL.class);
        Actor fireballR = getOneIntersectingObject(fireballR.class);
        if (fireballL!=null && Greenfoot.isKeyDown("k") == false && Greenfoot.isKeyDown("o") == false){

            healthR -= 20; 
            getWorld().removeObject(fireballL);
            attackBlocked = false;

        }//end

        if (fireballL!=null && Greenfoot.isKeyDown("k") == true && isGuardBroken == true)
        {
            healthR -= 20; 
            getWorld().removeObject(fireballL);
            attackBlocked = false;

        }

        if (fireballL!=null && Greenfoot.isKeyDown("o") == true && isGuardBroken == true)
        {
            healthR -= 20; 
            getWorld().removeObject(fireballL);
            attackBlocked = false;

        }

        if (fireballL!=null && Greenfoot.isKeyDown("9") == true){
            healthR -= 20; 
            getWorld().removeObject(fireballL);
            attackBlocked = false;
        }

        if (fireballL!=null && Greenfoot.isKeyDown("o") == true && Greenfoot.isKeyDown("k") == false && Greenfoot.isKeyDown("9") == false && isGuardBroken == false)
        {
            getWorld().removeObject(fireballL);
            shieldFXR.play();
            shieldTimer.mark();
            shieldR -=1;
            attackBlocked = true;
            counterTimer.mark();
        }//end

        if (fireballR!=null && attackBlocked == true && counterTimer.millisElapsed() < 1000)
        {
            counterFXR.play();
            attackBlocked = false;

        }

    }//end

    public void hitDetectionSp3R () {
        Actor earthL = getOneIntersectingObject(earthL.class);
        Actor earthR = getOneIntersectingObject(earthR.class);
        if (earthL!=null && Greenfoot.isKeyDown("o") == false){

            healthR -= 20; 
            getWorld().removeObject(earthL);
            attackBlocked = false;

        }//end

        if (earthL!=null && isGuardBroken == true)
        {
            healthR -= 20; 
            getWorld().removeObject(earthL);
            attackBlocked = false;

        }

        if (earthL!=null && Greenfoot.isKeyDown("o") == true && isGuardBroken == true)
        {
            healthR -= 20; 
            getWorld().removeObject(earthL);
            attackBlocked = false;

        }

        if (earthL!=null && Greenfoot.isKeyDown("o") == true && isGuardBroken == false && Greenfoot.isKeyDown("k") == false)
        {
            healthR -= 20; 
            getWorld().removeObject(earthL);
            attackBlocked = false;

        }

        if (earthL!=null && Greenfoot.isKeyDown("8") == true){
            healthR -= 20; 
            getWorld().removeObject(earthL);
            attackBlocked = false;
        }

        if (earthL!=null && Greenfoot.isKeyDown("o") == true  && Greenfoot.isKeyDown("k") == true && Greenfoot.isKeyDown("8") == false && isGuardBroken == false)
        {
            getWorld().removeObject(earthL);
            shieldFXR.play();
            shieldTimer.mark();
            shieldR -=1;
            attackBlocked = true;
            counterTimer.mark();
        }//end

        if (earthR!=null && attackBlocked == true && counterTimer.millisElapsed() < 1000)
        {
            counterFXR.play();
            attackBlocked = false;

        }

    }//end

    public void checkObstacle()
    {
        Actor midWall = getOneIntersectingObject(blackLine.class);
        Actor rightWall = getOneIntersectingObject(rightWall.class);
        if (midWall!=null)
        {
            move(+4);

        }//end
        if (rightWall!=null)
        {
            move(-4);

        }//end

    }//end

    // ACT METHOD IS HERE
    public void act()
    {
        // by default, stick02 is idle
        idle();

        // stickman02 blocks upon pressing "o" key
        blocking();

        // stickman02 backWalks upon pressing the "l" key
        backWalking();

        // stickman02 crouches upon pressing the "k" key
        crouching();

        crouchBlock();

        // stickman02 walks upon pressing the "j" key
        walking();

        //makes footstep noises
        walkSounds();

        //makes backstep noises
        backWalkSounds();

        // stickman02 casts a fireball (super-power-#2) upon pressing the "2" key
        sp3check();

        sp2check();

        sp1check();

        // if stickman02 is hit by stickman01's sp2 then stickman02 will die lol 
        hitDetectionSp3R();

        hitDetectionSp2R();

        hitDetectionSp1R();

        //stickman02 healthbar
        healthBarR();
        deathR();

        //stickman02 shieldbar
        shieldBar();

        //stickman02 guardbroken
        guardBreak();

    } //end
} //end
