import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class StartScreen here.
 * 
 * @author (Anas) 
 * @version (v1.5)
 */
// set the menu image and audio and also extend the world class
public class StartScreen extends World
{
    // set the gif to menuanim
    GifImage menuanim = new GifImage("csMenu.gif"); // menu screen
    // set the sound to "sound"
    GreenfootSound sound = new GreenfootSound("RainyMenu.mp3"); // menu music

    /**
     * Constructor for objects of class StartScreen.
     * 
     */

    public StartScreen()
    {    
        // Create a new world with 800x424 because thats the size of the image cells with a cell size of 1x1 pixels.
        super(800, 424, 1);   
    } //end

    // everything here is executed every act cycle
    public void act()
    { 
        // execute the menuanim that was set beforehand
        setBackground(menuanim.getCurrentImage()); // set the background
        // execute the audio that was setup beforehand
        sound.play(); // set the tunes
        // if greenfootGetKey detection is equal to enter key
        String key = Greenfoot.getKey();
        if ("enter".equals(key))
        {
            // stop the audio for the menu screen
            sound.stop();
            // set execution to MyWorld which is the game
            Greenfoot.setWorld(new MyWorld());

        } //end
    } //end
} //end
